#include <dos.h>
#include <conio.h>
#include <stdlib.h>
#include <math.h>
#include <stdio.h>
#include <mem.h>
#include <fcntl.h>
#include <io.h>
#include <time.h>
#define light 5

typedef unsigned char byte;
typedef short unsigned word;
typedef unsigned long dword;



typedef struct {
				 short int a;
				 short int b;
				 short int c;
				}FACE;
				
typedef struct {
				 long x;
				 long y;
				 long z;
				}NORMAL;        
				
typedef struct {
				 short int x;
				 short int y;
				 short int z;
				}VERTEX;

typedef struct {
				 long int x;
				 long int y;
				 long int z;
				}IVERTEX;
				
/* to change if want more speed */
typedef struct {
				 float x;
				 float y;
				 float z;
				}FVERTEX;

typedef struct {
				 long int z;
				 word noface;
				}CENTROID;
				
typedef struct {
				short int x;
				short int y;
			   }TEXTURE; 

typedef struct{
					float x;
					float y;
					float lx;
					float ly;
					float pwr;
				  }LIGHT;
				  
typedef struct{
					float x;
					float y;
					float pwr;
				 }SOURCE;


struct COLORS
	{ 
	  byte red;
	  byte green;
	  byte blue;
	};

				 
/***************************************************************************/
/*                          Global Data                                    */
/***************************************************************************/




/***************************************************************************/
/*                           Prototypes                                    */
/***************************************************************************/

void init_light(int n,float x,float y, float pwr);
void init_source(int n,float x,float y, float pwr);
float lighting(LIGHT tlight);
void fadebuf(byte *buf);
void shadeline(word x,word y,word x2,word y2,byte *buf11,byte *buf22);
void line(word x,word y,word x2,word y2,byte col,byte *buf1);
void fade(struct COLORS *cp,word intensity,word start,word end,byte *palbuf);
void waitr(void);
void rotate(VERTEX *O, VERTEX *I,word tvertex,byte ax,byte ay,byte az,word posx,word posy,word posz);
void mode13(void);
void mode3(void);
void setpal(byte *pal);
void make_angle(void);
void gourad(long x1,long y1,long x2,long y2,long x3,long y3,long c1,long c2,
			  long  c3,byte *buf);
void map(long x1,long y1,long x2,long y2,long x3,long y3,byte *buf,
			 long tx1,long ty1,long tx2,long ty2,long tx3,long ty3,byte *from);

void scroll13h(dword xstart,word sy,word ey,byte *dest,byte *source);
void initwind(void);
void wind(void);
void Yshadeline(word x,word y,word x2,word y2,byte *buf1);
void Yfade(struct COLORS *cp,word intensity,word start,word end,byte *palbuf);


/***************************************************************************/
/*                          class objet3d                                  */
/***************************************************************************/



class objet3d
{
	public:
	int reference;
	unsigned short int tot_vertex;
	unsigned short int tot_face;
	IVERTEX center;
	IVERTEX icenter;
	FVERTEX Scenter;
	FVERTEX Ecenter;
	int zmax;
	byte ALL;
	float ax,ay,az;
	byte cs,ct;  // color stop.start;
	byte mstart;
	byte mend;
	float sax,say,saz;
	float eax,eay,eaz;
	float O[4][4];  
	byte mdraw;
	objet3d *parent;
	byte *TEXPTR;
	// if mdraw=1 then flat 
	// if mdraw=2 then gourad
	// if mdraw=3 then phong
	// if mdraw=4 then textem
	// if mdraw=0 then pixel
		  
	VERTEX  *vertex;
	IVERTEX *image;
	CENTROID *centroid;
	CENTROID *bufA,*bufB;
	FACE *face;
	NORMAL *normalo,*normali,*normalvi,*normalvo;
	TEXTURE *texture; 
	
	objet3d& load(char *name,byte no);
	objet3d& prenormal();
	objet3d& draw();
	objet3d& delet();
	objet3d& findnorm(void);
	objet3d& rotaten(short int anx,short int any,short int anz);

	objet3d& sort(int tot);
	objet3d& move(short int x,short int y,short int z);
	objet3d& set(objet3d *p,float nsax,float nsay,float nsaz,
	 float neax,float neay,float neaz,float aax,float aay,float aaz,
	 short int dx,short int dy,short int dz,float scx,float scy,float scz,
	 float ecx,float ecy,float ecz,byte ms,byte me,byte ccs,byte cct,byte md);
	objet3d& start(float aax,float aay,float aaz,short int dx,short int dy,short int dz);
	objet3d& end(float aax,float aay,float aaz,short int dx,short int dy,short int dz);
	objet3d& inta(float pos, float tot);
	objet3d& rotate();
	objet3d& litset(float aax,float aay,float aaz,short int dx,short int dy,short int dz);
	objet3d& dload(long posf,byte no);


};

void render(int nbr, objet3d *tab);
void sort_obj(int tot);

typedef struct {
					word len;
					word startx;
					word starty;
					word posx;
					word posy;
					word initx;
					word inity;
					byte sta;
					
			   }HAIR;

struct { word pos;
	 byte color;
       } pixel[800];

byte isvesa(void);
byte setvesamode(word mode);
void setwindow(byte win,word pos);
void memcpysvga(byte *dest,byte *source);
void baseport(void);

